<?php
  /**************************************************
  Coppermine Plugin - Facebook Authentication
  *************************************************
  Copyright (c) 2011 Marek Paterczyk
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License version 3
  as published by the Free Software Foundation.
  ***************************************************/
  require_once($CONFIG['plugin_facebookauth_firephp_path'] . 'FirePHP.class.php');
  require_once('include/mailer.inc.php');

  $fp = FirePHP::getInstance(true);
  $fp->setEnabled($CONFIG['plugin_facebookauth_debug']);
  $fp->trace("facebookauth.php started");

  if (!defined('IN_COPPERMINE'))
      die('Not in Coppermine...');

  if (!isset($_SESSION)) {
      session_id($superCage->cookie->getAlnum('PHPSESSID'));
      session_start();
  }

  $app_id     = $CONFIG['plugin_facebookauth_application_id'];
  $app_secret = $CONFIG['plugin_facebookauth_application_secret'];
  $auth_url   = $CONFIG['site_url'] . "facebookauth.php";


  $superCage = Inspekt::makeSuperCage();

  // author: http://www.howtogeek.com/howto/programming/php-get-the-contents-of-a-web-page-rss-feed-or-xml-file-into-a-string-variable/
  function get_url_contents($url)
  {
      $crl     = curl_init();
      $timeout = 5;
      curl_setopt($crl, CURLOPT_URL, $url);
      curl_setopt($crl, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($crl, CURLOPT_CONNECTTIMEOUT, $timeout);
      $ret = curl_exec($crl);
      curl_close($crl);
      return $ret;
  }

  // author: http://www.laughing-buddha.net/php/lib/password
  function generatePassword($length = 40)
  {
      // start with a blank password
      $password = "";

      // define possible characters - any character in this string can be
      // picked for use in the password, so if you want to put vowels back in
      // or add special characters such as exclamation marks, this is where
      // you should do it
      $possible = "2346789bcdfghjkmnpqrtvwxyzBCDFGHJKLMNPQRTVWXYZ";

      // we refer to the length of $possible a few times, so let's grab it now
      $maxlength = strlen($possible);

      // check for length overflow and truncate if necessary
      if ($length > $maxlength) {
          $length = $maxlength;
      }

      // set up a counter for how many characters are in the password so far
      $i = 0;

      // add random characters to $password until $length is reached
      while ($i < $length) {
          // pick a random character from the possible ones
          $char = substr($possible, mt_rand(0, $maxlength - 1), 1);

          // have we already used this character in $password?
          if (!strstr($password, $char)) {
              // no, so it's OK to add it onto the end of whatever we've already got...
              $password .= $char;
              // ... and increase the counter by one
              $i++;
          }
      }

      // done!
      return $password;
  }

  function notify_admins($user_name)
  {
      global $CONFIG, $fp;

      $fp->trace("Entered notify_admins");
      $body = <<< EOT
Facebook Authentication Plugin created a new user account. If you want to disable this notification, set plugin_facebookauth_newuser_notify=0.

Best Regards
Facebook Authentication Plugin
EOT;

      cpg_mail(admin, "New facebook user: $user_name", nl2br($body));
  }

  function register_user_if_not_exists($user)
  {
      global $CONFIG, $fp;

      $username            = "fb" . $user->id;
      $email               = $user->email;
      $name                = $user->name;
      $dummy_password      = generatePassword();
      $dummy_password_hash = md5($dummy_password);

      $sql = "SELECT user_name FROM " . $CONFIG['TABLE_USERS'] . " WHERE user_name='$username'";
      $fp->info($sql);
      $result = cpg_db_query($sql);
      if (mysql_num_rows($result) == 0) {
          $fp->info("User does not exist in cpg");
          if (!$CONFIG['plugin_facebookauth_newuser_allow']) {
              return NULL;
          }

          $group_id = 2;

          $sql = "INSERT INTO {$CONFIG['TABLE_USERS']} (user_regdate, user_active, user_actkey, user_name, user_password, user_email, user_profile1, user_profile2, user_profile3, user_profile4, user_profile5, user_profile6, user_language) VALUES (NOW(), 'YES', '', '$username', '$dummy_password_hash', '$email', '', '', '', '', '', '', 'english')";
          $fp->info($sql);
          cpg_db_query($sql);

          $sql = "INSERT INTO {$CONFIG['TABLE_PREFIX']}plugin_facebookauth_users(cpg_user_id, name) VALUES((SELECT user_id FROM {$CONFIG['TABLE_USERS']} WHERE user_name = '$username'), '$name')";
          $fp->info($sql);
          cpg_db_query($sql);
          log_write("Created facebook user $username");
          $fp->trace("Created facebook user $username");

          if ($CONFIG['plugin_facebookauth_newuser_notify']) {
              notify_admins("$name [$email]");
          }
      } else {
          $sql = "UPDATE {$CONFIG['TABLE_USERS']} SET user_password = '$dummy_password_hash', user_email = '$email' WHERE user_name = '$username'";
          $fp->info($sql);
          cpg_db_query($sql);

          $sql = "UPDATE  {$CONFIG['TABLE_PREFIX']}plugin_facebookauth_users SET name = '$name' WHERE cpg_user_id = (SELECT user_id FROM {$CONFIG['TABLE_USERS']} WHERE user_name = '$username')";
          $fp->info($sql);
          cpg_db_query($sql);

          $fp->trace("$username updated");
      }
      mysql_free_result($result);
      return $dummy_password;
  }


  print("Stand by, authentication in progress...");
  $code = $superCage->get->getRaw('code');
  if (empty($code)) {
      //CSRF protection
      $_SESSION['state'] = md5(uniqid(rand(), true));
      if ($superCage->get->keyExists('redirect_url')) {
          $_SESSION['redirect_url'] = $superCage->get->getRaw('redirect_url');
      } else {
          $_SESSION['redirect_url'] = $CONFIG['site_url'];
      }
      $dialog_url = "https://www.facebook.com/dialog/oauth?client_id=" . $app_id . "&redirect_uri=" . urlencode($auth_url) . "&scope=email&state=" . $_SESSION['state'];

      $fp->trace("Requesting code... (redirect): $dialog_url");
      echo ("<script> top.location.href='" . $dialog_url . "'</script>");
  } elseif ($superCage->get->getRaw('state') == $_SESSION['state']) {
      $token_url = "https://graph.facebook.com/oauth/access_token?client_id=$app_id&redirect_uri=$auth_url&client_secret=$app_secret&code=$code";

      $fp->trace("Got code. Requesting token...");
      $response = get_url_contents($token_url);
      $fp->trace("Got token");
      $params = null;
      parse_str($response, $params);

      $graph_url = "https://graph.facebook.com/me?access_token=" . $params['access_token'];

      $fp->trace("Calling me service to obtain user information");
      $me        = get_url_contents($graph_url);
      $user_json = get_url_contents($graph_url);
      $user      = json_decode($user_json);
      $fp->info($user);

      if (empty($user->id)) {
          $fp->error("Something's wrong. User failed validation.");
          log_write("Facebook authentication failed...");
          log_write($user_json);
          cpg_die(ERROR, "Facebook authentication failed...<br/><br/>" . $user_json, __FILE__, __LINE__);
      }

      $dummy_password = register_user_if_not_exists($user);
      if ($dummy_password && $USER_DATA = $cpg_udb->login("fb" . $user->id, $dummy_password, false)) {
          $fp->trace($USER_DATA);
          if (!$USER_DATA['has_admin_access']) {
              unset($USER['am']);
              user_save_profile();
          }

          $fp->trace("User authenticated");

          $redirect_url = $_SESSION['redirect_url'];
          if (empty($redirect_url)) {
              $redirect_url = 'index.php';
          }

          $fp->trace("About to redirect back to $redirect_url");
          $pending_approvals = ($USER_DATA['has_admin_access'] && cpg_get_pending_approvals() > 0) ? '<br />' . $lang_gallery_admin_menu['upl_app_title'] : '';
          // why is this not showing a message?
          cpgRedirectPage($redirect_url, $lang_login_php['login'], sprintf($lang_login_php['welcome'], $USER_DATA['user_name']) . $pending_approvals, 3, 'success');
          exit;
      } elseif ($dummy_password == NULL) {
          $fp->info($user->name . " attempted to register, but user registeration is disabled.");
          log_write($user->name . " attempted to register, but user registeration is disabled.");
          cpg_die(INFORMATION, "User registration has been disabled by the administrator. Only existing users can login.", __FILE__, __LINE__);
      }
  } else {
      $fp->error("The state does not match. You may be a victim of CSRF.");
      $fp->trace("state from session: " . $_SESSION['state'] . ", state got from facebook: " . $superCage->get->getRaw('state'));
      log_write("Facebook authentication failed... The state does not match. You may be a victim of CSRF.");
      log_write("state from session: " . $_SESSION['state'] . ", state got from facebook: " . $superCage->get->getRaw('state'));
      cpg_die(ERROR, "Facebook authentication failed... <br/><br/>The state does not match. You may be a victim of CSRF.", __FILE__, __LINE__);
  }

  $fp->trace("facebookauth.php completed");
?>
